#include <stdio.h>
#include <string.h>

extern "C" {
    int InitComm(const char* szPort);
    void Authenticate();
    int ReadCard(char* szTxt, char* szWlt2048, char* szBmp38862);
    int GetSamdId(char* szSamId);
    void CloseComm();
}

#include <iconv.h>
#include <sys/stat.h>
#include <locale.h>

int code_convert(char *from_charset, char *to_charset, char *inbuf, size_t inlen,
char *outbuf, size_t outlen) {
iconv_t cd;
char **pin = &inbuf;
char **pout = &outbuf;


cd = iconv_open(to_charset, from_charset);
if (cd == 0)
return -1;
memset(outbuf, 0, outlen);
if (iconv(cd, pin, &inlen, pout, &outlen) == -1)
return -1;
iconv_close(cd);
*pout = '\0';


return 0;
}


int u2g(char *inbuf, size_t inlen, char *outbuf, size_t outlen) {
return code_convert("utf-8", "gbk", inbuf, inlen, outbuf, outlen);
}


int g2u(char *inbuf, size_t inlen, char *outbuf, size_t outlen) {
return code_convert("gbk", "utf-8", inbuf, inlen, outbuf, outlen);
}

int writeFile(const char* szFileName, char *szData, int iLen)
{
    FILE *fp;
    if((fp= fopen(szFileName,"wb"))==NULL)
        return 0;

    fwrite(szData, 1, iLen, fp);
    fclose(fp);
    return 1;
}

int main(void)
{
	int iRet = InitComm("usb");
	if (iRet != 1){
		printf("InitComm error %d\r\n", iRet);
		return -1;
	}
	Authenticate();
	
	
        char szTxt[1024] = {0};
        char szWlt2048[2048] = {0};
        char szBmp38862[38862] = {0};
        iRet = ReadCard(szTxt, szWlt2048, szBmp38862);
	if (iRet != 1){
		printf("ReadCard error %d\r\n", iRet);
		return -1;
	}
	CloseComm();

	writeFile("/opt/apps/reader-driver-invstermb/bin/zp.bmp", szBmp38862, 38862);
	char szUtf8Txt[1024] = {0};
	int iLen = g2u(szTxt, strlen(szTxt), szUtf8Txt, 1024);
	writeFile("/opt/apps/reader-driver-invstermb/bin/wz.txt", szTxt, strlen(szTxt));
	printf("card data %s\r\n", szUtf8Txt);
	return 0;
}

//g++ -ot test.cpp -L./ -ltermb

